#include <iostream>
#include <stdio.h>
#include <string>
#include <algorithm>
#include <map>
#include <vector>

using namespace std;


string curr_best_pattern = "";
int curr_best_score = -1;


struct FindT {
	int value;
	int last_position;

	FindT(): value(0), last_position(0) {  }
};


struct NodeFindT
{
	NodeFindT* node[10];
	FindT f[10];

	NodeFindT()
	{
		memset(f, 0, sizeof(f));
		memset(node, 0, sizeof(node));
	}

	~NodeFindT()
	{
		for (int i = 0; i < 10; i++) {
			if (node[i]) {
				delete node[i];
			}
		}
	}
};


struct TrieT
{
	NodeFindT* node;

	TrieT(int len)
	{
		node = new NodeFindT();
	}

	~TrieT()
	{
		delete node;
	}


	void check(const string& s, int curr_pattern_pos)
	{
		string curr_pattern = "";
		NodeFindT** curr = &node;
		for (int i = 0; i < s.length(); i++) {
			char c = s[i] - '0';
			curr_pattern += s[i];
			if (!*curr) {
				*curr = new NodeFindT();
			}
			FindT& f = static_cast<NodeFindT*>(*curr)->f[c];

			if (!f.value || f.last_position + (i+1) <= curr_pattern_pos) {
				f.last_position = curr_pattern_pos;
				int curr_score = (++f.value) * (i+1);
				if (curr_score >= curr_best_score) {
					if(curr_score == curr_best_score) {
						curr_best_pattern = min(curr_best_pattern, curr_pattern);
					} else {
						curr_best_pattern = curr_pattern;
						curr_best_score = curr_score;
					}
				}
			}

			curr = &(*curr)->node[c];
		}
	}
};


int l;
string s;
//map<string, FindT> v;


inline void Assert(bool cond, const string& msg)
{
	if (!cond) {
		cerr << msg << endl;
		exit(216);
	}
}


int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	cin >> l >> s;
	TrieT v(l);

//	Assert(l <= s.length(), "Pattern length more than number length");

	for (int i = 0; i < s.length(); i++) {
		string curr_max_pattern = s.substr(i, min<int>(l, s.length() - i));
		v.check(curr_max_pattern, i);
	}

	l = curr_best_pattern.length();
	char last_sign = '-';
	for (int i = 0; i < s.length(); ) {
		if (i + l <= s.length() && s.substr(i, l) == curr_best_pattern) {
			i += l;
			cout << (last_sign == '-' ? "" : "-") << curr_best_pattern << (i < s.length() ? "-" : "");
			last_sign = '-';

		} else {
			cout << (last_sign = s[i++]);
		}
	}

	cout << endl;
	//cout << endl << curr_best_score << endl << curr_best_pattern;
	

	fclose(stdin);
	fclose(stdout);
	return 0;
}
